<!-----------------------------------------------------------------------
Author 	 :	Your Name
Date     :	September 25, 2005
Description :

	fwsample.system.eventhandler

----------------------------------------------------------------------->
<cfcomponent name="ehForums" extends="coldboxSamples.system.eventhandler">

	<!---
		Constructor Goes Here if Needed
	--->

	<!--- ************************************************************* --->
	<!---
		Remember that the returntype needs to be the same as the cfc name
		This method should not be altered, unless you want code to be executed
		when this handler is instantiated.
	--->
	<cffunction name="init" access="public" returntype="Any">
		<cfargument name="controller" required="yes" hint="The reference to the framework controller">
		<cfset super.init(arguments.controller)>
		<cfreturn this>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="onAppStart" access="public" returntype="void" output="false">
		<!--- App Init Code --->
		<cfset structDelete(application, "userCache")>
		<!--- Get main settings --->
		<cfinvoke component="#getSetting("AppCFMXMapping")#/cfcs/galleon" method="getSettings" returnVariable="settings">
		<cfset application.settings = settings>
		<!--- get user CFC --->
		<cfset application.user = createObject("component","#getSetting("AppCFMXMapping")#.cfcs.user").init(application.settings)>
		<!--- get utils CFC --->
		<cfset application.utils = createObject("component","#getSetting("AppCFMXMapping")#.cfcs.utils")>
		<!--- get conference CFC --->
		<cfset application.conference = createObject("component","#getSetting("AppCFMXMapping")#.cfcs.conference").init(application.settings)>
		<!--- get forum CFC --->
		<cfset application.forum = createObject("component","#getSetting("AppCFMXMapping")#.cfcs.forum").init(application.settings)>
		<!--- get thread CFC --->
		<cfset application.thread = createObject("component","#getSetting("AppCFMXMapping")#.cfcs.thread").init(application.settings)>
		<!--- get message CFC --->
		<cfset application.message = createObject("component","#getSetting("AppCFMXMapping")#.cfcs.message").init(application.settings)>
		<!--- get rank CFC --->
		<cfset application.rank = createObject("component","#getSetting("AppCFMXMapping")#.cfcs.rank").init(application.settings)>
		<cfset application.init = true>		
	</cffunction>
	<!--- ************************************************************* --->
	
	<!--- ************************************************************* --->
	<cffunction name="onRequestStart" access="public" returntype="void" output="false">

		<!--- Logout Code --->
		<cfif valueExists("logout")>
			<cfset doLogout()>
		</cfif>

		<!--- handle security --->
		<cflogin></cflogin>

		<!--- Used by index, forums, and threads ---->
		<!--- however, if threads, default to lastpost --->
		<!--- however, don't do this in the admin ;) --->
		<cfif not findNoCase("/admin", cgi.script_name)>
			<cfif findNoCase("dspThreads", cgi.script_name)>
				<cfif not valueExists("sort")>
					<cfset setValue("sort","lastpost")>
				</cfif>
				<cfif not valueExists("sortdir")>
					<cfset setValue("sortdir","desc")>
				</cfif>
			<cfelse>
				<cfif not valueExists("sort")>
					<cfset setValue("sort","name")>
				</cfif>
				<cfif not valueExists("sortdir")>
					<cfset setValue("sortdir","asc")>
				</cfif>
			</cfif>
		</cfif>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="onRequestEnd" access="public" returntype="void">
	<!--- ON Request End Here --->
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspHome" access="public" returntype="void">
		<!--- Do Your Logic Here to prepare a view --->

		<!--- get my conferences --->
		<cfset data = application.conference.getConferences()>
		<!--- if just one, auto go to a forums for it --->
		<cfif data.recordCount is 1>
			<cfset setNextEvent("ehForums.dspForums","conferenceid=#data.id#")>
		</cfif>
		<!--- sort --->
		<cfset data = request.udf.querySort(data,getValue("sort"),getValue("sortdir"))>
		<!--- determine max pages --->
		<cfif data.recordCount and data.recordCount gt application.settings.perpage>
			<cfset setValue("pages",ceiling(data.recordCount / application.settings.perpage)) >
		<cfelse>
			<cfset setValue("pages",1)>
		</cfif>
		<!--- Set data in request collection --->
		<cfset setValue("data",data)>
		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwIndex")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspForums" access="public" returntype="void">
		<cfif not valueExists("conferenceid") or not len(getValue("conferenceid"))>
			<cfset setnextEvent("ehForums.dspHome")>
		</cfif>
		<!--- get parent conference --->
		<cftry>
			<cfset request.conference = application.conference.getConference(getValue("conferenceid"))>
			<cfcatch>
				<cfset setnextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- get my forums --->
		<cfset data = application.forum.getForums(conferenceid=Getvalue("conferenceid")) >

		<!--- sort --->
		<cfset data = request.udf.querySort(data,getValue("sort"),getValue("sortdir")) >

		<!--- determine max pages --->
		<cfif data.recordCount and data.recordCount gt application.settings.perpage>
			<cfset setValue("pages", ceiling(data.recordCount / application.settings.perpage) )>
		<cfelse>
			<cfset setValue("pages", 1)>
		</cfif>
		<!--- Set Data --->
		<cfset setValue("data",data)>

		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon : #request.conference.name#")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwForums")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspProfile" access="public" returntype="void">
		<!--- Check if Logged On --->
		<cfif not request.udf.isLoggedOn()>
			<cfset thisPage = cgi.script_name & "?" & cgi.query_string>
			<cfset setNextEvent("ehForums.dspLogin","ref=#urlEncodedFormat(thisPage)#")>
		</cfif>

		<!--- attempt to subscribe --->
		<cfif valueExists("s")>
			<cftry>
			<cfif valueExists("threadid")>
				<cfset subMode = "thread">
				<cfset subID = getValue("threadID")>
				<cfset thread = application.thread.getThread(subID)>
				<cfset name = thread.name>
			<cfelseif valueExists("forumid")>
				<cfset subMode = "forum">
				<cfset subID = getValue("forumid")>
				<cfset forum = application.forum.getForum(subID)>
				<cfset name = forum.name>
			<cfelseif valueExists("conferenceid")>
				<cfset subMode = "conference">
				<cfset subID = getValue("conferenceid")>
				<cfset conference = application.conference.getConference(subid)>
				<cfset name = conference.name>
			</cfif>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
			</cftry>
			<cfif isDefined("variables.subMode")>
				<cfset application.user.subscribe(getAuthUser(), subMode, subID)>
				<cfset setValue("confirm","subscribe") >
				<cfset getPlugin("messagebox").setMessage("info","You have been subscribed to the #submode#: <b>#name#</b>")>
			</cfif>

		</cfif>

		<cfset setValue("user", application.user.getUser(getAuthUser()) )>
		<cfset setValue("subs", application.user.getSubscriptions(getAuthUser()) )>

		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon : Profile")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwProfile")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doRemoveSub" access="public" returntype="void">
		<cftry>
			<cfset application.user.unsubscribe(getAuthUser(), getValue("removeSub"))>
			<cfset subscribeMessage = "Your unsubscribe request has been processed.<br>">
			<cfset getPlugin("messagebox").setMessage("info","You have been Unsubscribed successfully.")>
			<cfcatch>
				<!--- silently fail ---><cfdump var="#cfcatch#"><cfabort>
			</cfcatch>
		</cftry>

		<!--- Redirect --->
		<cfset setNextEvent("ehForums.dspProfile","confirm=subscribe")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doSaveProfile" access="public" returntype="void">
		<!--- Get User Info --->
		<cfset user = application.user.getUser(getAuthUser())>

		<cfset errors = "">
		<cfif not len(trim(getValue("emailaddress"))) or not request.udf.isEmail(getValue("emailaddress"))>
			<cfset errors = errors & "You must enter a valid email address.<br>">
		<cfelse>
			<cfset user.emailaddress = trim(htmlEditFormat(getValue("emailaddress")))>
		</cfif>

		<cfif len(trim(getValue("password_new"))) and getValue("password_new") neq getValue("password_confirm")>
			<cfset errors = errors & "To change your password, your confirmation password must match.<br>">
		</cfif>
		<!--- Save if no Errors --->
		<cfif not len(errors)>
			<cfif len(trim(getValue("password_new")))>
				<cfset user.password = getValue("password_new")>
			</cfif>
			<cfset application.user.saveUser(getAuthUser(),user.password,user.emailaddress,user.datecreated,application.user.getGroupsForUser(getAuthUser()))>
			<cfset getPlugin("messagebox").setMessage("info","Your profile has been updated.")>
		<cfelse>
			<cfset getPlugin("messagebox").setMessage("info",errors)>
		</cfif>
		<!--- Redirect --->
		<cfset setNextEvent("ehForums.dspProfile","confirm=profile")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspLogin" access="public" returntype="void">
		<!--- Do Your Logic Here to prepare a view --->


		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwLogin")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doLogin" access="public" returntype="void">
		<!--- handle security --->
		<cflogin>
			<cfif application.user.authenticate(trim(getValue("username")), trim(getValue("password")))>
				<!--- good logon, grab their groups --->
				<cfset mygroups = application.user.getGroupsForUser(trim(getValue("username")))>
				<cfset session.user = application.user.getUser(trim(getValue("username")))>
				<cfloginuser name="#trim(getValue("username"))#" password="#trim(getValue("password"))#" roles="#mygroups#">
			<cfelse>
				<cfset getPlugin("messagebox").setMessage("error","Your username and password did not work.")>
				<cfset setNextEvent("ehForums.dspLogin","failedLogon=true&ref=#getValue("ref")#")>
			</cfif>
		</cflogin>
		<!--- SuccessFull Login --->
		<cfif request.udf.isLoggedOn()>
			<cfif getvalue("ref") neq "">
				<cflocation url="#getValue("ref")#" addToken="false">
			<cfelse>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfif>
		</cfif>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doLogout" access="public" returntype="void">
		<!--- handle security --->
		<cflogout>
		<cfset setNextEvent("ehForums.dspHome")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doRegister" access="public" returntype="void">
		<cfset errors = "">
		<cfif not len(trim(getValue("username_new"))) or not request.udf.isValidUsername(getValue("username_new"))>
			<cfset errors = errors & "You must enter a username. Only letters and numbers are allowed.<br>">
		</cfif>

		<cfif not len(trim(getValue("emailaddress"))) or not request.udf.isEmail(getValue("emailaddress"))>
			<cfset errors = errors & "You must enter a valid email address.<br>">
		</cfif>

		<cfif not valueExists("password_new") or not len(trim(getValue("password_new"))) or getValue("password_new") neq getValue("password_new2")>
			<cfset errors = errors & "You must enter a valid password that matches the confirmation.<br>">
		</cfif>

		<cfif not len(errors)>
			<cftry>
				<cfset application.user.addUser(trim(getValue("username_new")),trim(getValue("password_new")),trim(getValue("emailaddress")),"forumsmember")>
				<cfset mygroups = application.user.getGroupsForUser(trim(getValue("username_new")))>
				<cflogin>
					<cfset session.user = application.user.getUser(trim(getValue("username_new")))>
					<cfloginuser name="#trim(getValue("username_new"))#" password="#trim(form.password_new)#" roles="#mygroups#">
				</cflogin>

				<cfif getValue("ref") neq "">
					<cflocation url="#getValue("ref")#" addToken="false">
				<cfelse>
					<cfset setNextEvent("ehForums.dspHome")>
				</cfif>
				<cfcatch type="user cfc">
					<cfif findNoCase("User already exists",cfcatch.message)>
						<cfset errors = errors & "This username already exists.<br>">
					</cfif>
				</cfcatch>
				<cfcatch type="any">
					<cfset errors = "General DB error.">
					<!---
					<cfdump var="#cfcatch.detail#">
					<cfdump var="#cfcatch.message#">
					<cfdump var="#cfcatch.tagcontext#">
					<cfdump var="#cfcatch#">
					--->
				</cfcatch>
			</cftry>
		</cfif>
		<!--- Errors Occurred --->
		<cfset getPlugin("messagebox").setMessage("error",errors)>
		<!--- Set Next Events --->
		<cfset setNextEvent("ehForums.dspLogin","failedRegistration=true&ref=#getValue("ref")#")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doPasswordReminder" access="public" returntype="void">
		<!--- Do Your Logic Here to prepare a view --->
		<cfset data = application.user.getUser(trim(getValue("username_lookup")))>
		<cfif data.emailaddress is not "">
			<cfmail to="#data.emailaddress#" from="#application.settings.fromAddress#" subject="Galleon Password Reminder">
	This is a password reminder from the Galleon Forums at #application.settings.rooturl#.
	Your password is: #data.password#
			</cfmail>
			<cfset getPlugin("messagebox").setMessage("info", "A reminder has been sent to your email address.")>
		<cfelse>
			<cfset getPlugin("messagebox").setMessage("error", "Sorry, but your username could not be found in our system.")>
		</cfif>

		<!--- Set the View To Display, after Logic --->
		<cfset setNextEvent("ehForums.dspLogin","passreminder=true&ref=#getValue("ref")#")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspThreads" access="public" returntype="void">
		<cfif not valueExists("forumid") or not len(getValue("forumid"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<!--- get parents --->
		<cftry>
			<cfset request.forum = application.forum.getForum(getValue("forumid"))>
			<cfset request.conference = application.conference.getConference(request.forum.conferenceidfk)>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- get my threads --->
		<cfset data = application.thread.getThreads(forumid=getvalue("forumid"))>

		<!--- sort --->
		<cfset data = request.udf.querySort(data,getValue("sort"),getValue("sortdir"))>

		<!--- determine max pages --->
		<cfif data.recordCount and data.recordCount gt application.settings.perpage>
			<cfset setValue("pages",ceiling(data.recordCount / application.settings.perpage))>
		<cfelse>
			<cfset setValue("pages",1)>
		</cfif>
		<!--- set data --->
		<cfset setValue("data",data)>
		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon : #request.conference.name# : #request.forum.name#")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwThreads")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspNewPost" access="public" returntype="void">
		<cfif not request.udf.isLoggedOn()>
			<cfset thisPage = cgi.script_name & "?" & cgi.query_string>
			<cfset setNextEvent("ehForums.dspLogin","ref=#urlEncodedFormat(thisPage)#")>
		</cfif>

		<cfif not valueExists("forumid") or not len(getValue("forumid"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<!--- checks to see if we can post --->
		<cfset setValue("blockedAttempt", false)>

		<!--- get parents --->
		<cftry>
			<cfset request.forum = application.forum.getForum(getvalue("forumid"))>
			<cfset request.conference = application.conference.getConference(request.forum.conferenceidfk)>
			<!--- check both thread and forum for readonly and not admin --->
			<cfif request.forum.readonly or (isDefined("request.thread") and request.thread.readonly)>
				<cfif not application.utils.isUserInAnyRole("forumsadmin,forumsmoderator")>
					<cfset setValue("blockedAttempt", true)>
				</cfif>
			</cfif>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon : New Post")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwNewpost")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doPost" access="public" returntype="void">


		<cfif not request.udf.isLoggedOn()>
			<cfset thisPage = cgi.script_name & "?" & cgi.query_string>
			<cfset setNextEvent("ehForums.dspLogin","ref=#urlEncodedFormat(thisPage)#")>
		</cfif>

		<cfif not valueExists("forumid") or not len(getValue("forumid"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<cfset errors = "">

		<!--- clean the fields --->
		<cfset setValue("title", trim(htmlEditFormat(getvalue("post_title"))) )>
		<cfset setValue("body", trim(htmlEditFormat(getValue("body"))) )>

		<cfif not len(getvalue("post_title"))>
			<cfset errors = errors & "You must enter a title.<br>">
		</cfif>

		<cfif not len(getValue("body"))>
			<cfset errors = errors & "You must enter a body.<br>">
		</cfif>

		<cfif len(getvalue("post_title")) gt 50>
			<cfset errors = errors & "Your title is too long.<br>">
		</cfif>

		<cfif not len(errors)>
			<cfset message = structNew()>
			<cfset message.title = getvalue("post_title")>
			<cfset message.body = getValue("body")>
			<cfset args = structNew()>
			<cfset args.message = message>
			<cfset args.forumid = getValue("forumid")>
			<cfset msgid = application.message.addMessage(argumentCollection=args)>
			<!--- get the message so we can get thread id --->
			<cfset message = application.message.getMessage(msgid)>
			<cfif getValue("subscribe",false)>
				<cfset application.user.subscribe(getAuthUser(), "thread", message.threadidfk)>
			</cfif>
			<!--- clear my user info --->
			<cfset uinfo = request.udf.cachedUserInfo(getAuthUser(), false)>
			<cfset setNextEvent("ehForums.dspMessages","threadid=#message.threadidfk#")>
		</cfif>

		<cfset getPlugin("messagebox").setMessage("error",errors)>
		<!--- Set the View To Display, after Logic --->
		<cfset setNextEvent("ehForums.dspNewPost","posterrors&forumid=#getvalue("forumid")#")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspMessages" access="public" returntype="void">
		<cfif not valueExists("threadid") or not len(getValue("threadid"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<!--- get parents --->
		<cftry>
			<cfset request.thread = application.thread.getThread(getValue("threadid"))>
			<cfset request.forum = application.forum.getForum(request.thread.forumidfk)>
			<cfset request.conference = application.conference.getConference(request.forum.conferenceidfk)>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- determine if read only --->
		<cfif request.forum.readonly or request.thread.readonly>
			<cfset setValue("readonly", true)>
		<cfelse>
			<cfset setValue("readonly", false)>
		</cfif>

		<!--- get my messages --->
		<cfset data = application.message.getMessages(threadid=request.thread.id)>
		<!--- determine max pages --->
		<cfif data.recordCount and data.recordCount gt application.settings.perpage>
			<cfset setValue("pages", ceiling(data.recordCount / application.settings.perpage))>
		<cfelse>
			<cfset setvalue("pages",1)>
		</cfif>
		<!--- set data --->
		<cfset setValue("data",data)>

		<!--- Post Title --->
		<cfif not valueExists("post_title")>
			<cfset setValue("post_title","RE: #request.thread.name#")>
		</cfif>

		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon : #request.conference.name# : #request.forum.name# : #request.thread.name#")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwMessages")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doMessagePost" access="public" returntype="void">

		<cfif not valueExists("threadid") or not len(getValue("threadid"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>
		<!--- get parents --->
		<cftry>
			<cfset request.thread = application.thread.getThread(getValue("threadid"))>
			<cfset request.forum = application.forum.getForum(request.thread.forumidfk)>
			<cfset request.conference = application.conference.getConference(request.forum.conferenceidfk)>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- determine if read only --->
		<cfif request.forum.readonly or request.thread.readonly>
			<cfset setValue("readonly", true)>
		<cfelse>
			<cfset setValue("readonly", false)>
		</cfif>

		<cfif request.udf.isLoggedOn() and (application.utils.isUserInAnyRole("forumsadmin,forumsmoderator")) or not getValue("readonly")>

			<cfset errors = "">
			<!--- clean the fields --->
			<cfset setvalue("post_title",trim(htmlEditFormat(getValue("post_title"))))>
			<cfset setvalue("body", trim(htmlEditFormat(getValue("body"))))>

			<cfif not len(getValue("post_title"))>
				<cfset errors = errors & "You must enter a title.<br>">
			</cfif>
			<cfif not len(getValue("body"))>
				<cfset errors = errors & "You must enter a body.<br>">
			</cfif>

			<cfif len(getValue("post_title")) gt 100>
				<cfset errors = errors & "Your title is too long.<br>">
			</cfif>

			<cfif not len(errors)>
				<cfset message = structNew()>
				<cfset message.title = getValue("post_title")>
				<cfset message.body = getValue("body")>
				<cfset args = structNew()>
				<cfset args.message = message>
				<cfset args.forumid = request.forum.id>
				<cfset args.threadid = getValue("threadid")>
				<cfset msgid = application.message.addMessage(argumentCollection=args)>
				<cfif getValue("subscribe")>
					<cfset application.user.subscribe(getAuthUser(), "thread", getValue("threadid"))>
				</cfif>

				<!--- clear my user info --->
				<cfset uinfo = request.udf.cachedUserInfo(getAuthUser(), false)>
				<cfset setNextEvent("ehForums.dspMessages","threadid=#getValue("threadid")#&##top")>
			</cfif>
			<cfset getPlugin("messagebox").setMessage("error",errors)>
			<!--- Set the View To Display, after Logic --->
			<cfset setNextEvent("ehForums.dspMessages","posterrors&threadid=#getValue("threadid")#&##bottom")>
		<cfelse>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspMessageEdit" access="public" returntype="void">
		<cfif not request.udf.isLoggedOn() or not application.utils.isUserInAnyRole("forumsadmin,forumsmoderator")>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<cfif not valueExists("id") or not Len(getValue("id"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<!--- get parents --->
		<cftry>
			<cfset request.message = application.message.getMessage(getValue("id"))>
			<cfset request.thread = application.thread.getThread(request.message.threadidfk)>
			<cfset request.forum = application.forum.getForum(request.thread.forumidfk)>
			<cfset request.conference = application.conference.getConference(request.forum.conferenceidfk)>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- Set Variables to Edit --->
		<cfset setvalue("post_title",request.message.title)>
		<cfset setvalue("body",request.message.body)>


		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon : Edit Post")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwMessage_edit")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doEditPost" access="public" returntype="void">
		<cfif not request.udf.isLoggedOn() or not application.utils.isUserInAnyRole("forumsadmin,forumsmoderator")>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>
		<cfif not valueExists("id") or not Len(getValue("id"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<!--- get parents --->
		<cftry>
			<cfset request.message = application.message.getMessage(getValue("id"))>
			<cfset request.thread = application.thread.getThread(request.message.threadidfk)>
			<cfset request.forum = application.forum.getForum(request.thread.forumidfk)>
			<cfset request.conference = application.conference.getConference(request.forum.conferenceidfk)>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<cfset errors = "">

		<!--- clean the fields --->
		<cfset setValue("post_title", trim(htmlEditFormat(getValue("post_title"))))>
		<cfset setValue("body", trim(htmlEditFormat(form.body)))>

		<cfif not len(getValue("post_title"))>
			<cfset errors = errors & "You must enter a title.<br>">
		</cfif>

		<cfif not len(getValue("body"))>
			<cfset errors = errors & "You must enter a body.<br>">
		</cfif>

		<cfif len(getValue("post_title")) gt 50>
			<cfset errors = errors & "Your title is too long.<br>">
		</cfif>

		<cfif not len(errors)>
			<cfset message = structNew()>
			<cfset message.title = trim(htmlEditFormat(getValue("post_title")))>
			<cfset message.body = trim(htmlEditFormat(getValue("body")))>
			<cfset message.posted = request.message.posted>
			<cfset message.threadidfk = request.message.threadidfk>
			<cfset message.useridfk = request.message.useridfk>
			<cfset application.message.saveMessage(getValue("id"), message)>
			<cfset setNextEvent("ehForums.dspMessages","threadid=#message.threadidfk#")>
		</cfif>
		<cfset getPlugin("messagebox").setMessage("error",errors)>
		<!--- Set the View To Display, after Logic --->
		<cfset setNextEvent("ehForums.dspMessages","posterrors&threadid=#message.threadidfk#")>

	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspSearch" access="public" returntype="void">
		<!--- Set Title and Templatename --->
		<cfset setValue("title","Galleon : Search")>
		<cfset setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwSearch")>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doSearch" access="public" returntype="void">
		<!--- Handle attempted search --->
		<cfif not listFindNoCase("phrase,any,all", getValue("searchtype"))>
			<cfset setValue("searchtype","phrase")>
		</cfif>
		<!---
			search multiple items:
				conferences (name/desc)
				forums (name/desc)
				threads (name)
				messages (title/body)
		--->
		<cfset setValue("conferences", application.conference.search(getValue("searchterms"), getValue("searchtype")))>
		<cfset setValue("forums", application.forum.search(getValue("searchterms"), getValue("searchtype")))>
		<cfset setValue("threads", application.thread.search(getValue("searchterms"), getValue("searchtype")))>
		<cfset setValue("messages", application.message.search(getValue("searchterms"), getValue("searchtype")))>
		<cfset application.utils.logSearch(getValue("searchterms"), application.settings.dsn, application.settings.tableprefix)>
		<cfset setValue("totalResults",getValue("conferences").recordCount + getValue("forums").recordCount + getValue("threads").recordCount + getValue("messages").recordCount)>
		<!--- TeXtus feature, call other events --->
		<cfset dspSearch()>

	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspRss" access="public" returntype="void">
		<cfif not valueExists("conferenceid") or not len(getValue("conferenceid"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<!--- get parent conference --->
		<cftry>
			<cfset request.conference = application.conference.getConference(getValue("conferenceid"))>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- get my latest posts --->
		<cfset setValue("data", application.conference.getLatestPosts(conferenceid=getValue("conferenceid")))>

		<!--- Set the View To Display, after Logic --->
		<cfset setView("vwRss")>
	</cffunction>
	<!--- ************************************************************* --->

	</cfcomponent>