<!---------------------------------------------
CFC Viewer
October/2005 - by Oscar Arevalo (oarevalo@gmail.com)

This tool is used to display information about all components located within
the same directory. The tools is based on the coldfusion.runtime.TemplateProxy
java object to obtain this information. The tool displays information
regarding comments, methods, return types, and arguments.
Additionally, this tool scans each component for specially formatted TODO comments
to allow developers to keep track of pending tasks when developing their components.

---------------------------------------------->
<cftry>
<cfsetting showdebugoutput="no">
<!--- Reference --->
<cfset aCFC = getValue("aCFC")>
<cfset oCFCViewer = getValue("oCFCViewer")>

<cfif not valueExists("cfdoctype") >
	<cfoutput>
	<span class="dashboardTitles">#getresource("myapi")#:</span><br>
	<p>
  	#getresource("myapitext")#
  	</cfoutput>
  <br />
  </p>
	<a href="#thetop"></a>
	<input type="button" name="ColdBox" 			value="ColdBox System" class="buttons"
		   onClick="window.location='index.cfm?event=ehColdbox.dspAPI&type=system'">&nbsp;
	<input type="button" name="ColdBoxPlugins"   value="ColdBox Plugins" class="buttons"
		   onClick="window.location='index.cfm?event=ehColdbox.dspAPI&type=plugins'">&nbsp;
</cfif>

<cfif getValue("cfcPath") eq "">
<cfabort>
</cfif>

	<hr>
	<cfoutput>
		<span class="fw_blueText">Components (#Type#)</span>
		<ul>
			<cfloop from="1" to="#ArrayLen(aCFC)#" index="i">
				<li><a href="###aCFC[i]#">#aCFC[i]#</a></li>
			</cfloop>
			<cfif ArrayLen(aCFC) eq 0>
				<li><em>None</em></li>
			</cfif>
		</ul>
    </cfoutput>

   <!--- CFC Meta Data --->
	<cfloop from="1" to="#ArrayLen(aCFC)#" index="i">
		<cftry>
			<cfset mdpath = getValue("dirpath") & aCFC[i] & ".cfc">
			<cfset md = oCFCViewer.getCFCMetaData(aCFC[i])>
			<div>
			<cfmodule template="../includes/displayMetaData.cfm" metaData="#md#" path="#ExpandPath(mdpath)#">
			</div>
			<cfcatch type="lock">
				<cfoutput>
					<p>
					An error ocurred while retrieving metadata for component #aCFC[i]#.<br>
					#cfcatch.Message#
					</p>
				</cfoutput>
			</cfcatch>
		</cftry>
	</cfloop>

<cfcatch type="any">
	<b>An unexpected error ocurred!</b><br>
	<Cfoutput>
		#cfcatch.Message#<br>
		#cfcatch.Detail#<br>
	</Cfoutput>
</cfcatch>
</cftry>
