<cfsetting enablecfoutputonly=true>
<!-----------------------------------------------------------------------
Template :  frameworkError.cfm 
Author 	 :	Luis Majano
Date     :	September 25, 2005
Description : 			
	This template is used when the framework throws customs errors.
				
Modification History:		
01/06/2006 - Added full scope of the controller to avoid pointers.
06/08/2006 - Updated for coldbox.
06/09/2006 - changed isDefined to structKeyExists
----------------------------------------------------------------------->

	<cfif structKeyExists(session,"fwController")>
		<!--- Email the Bug Report --->
		<cfset session.fwController.getPlugin("logger").logError("Exception Error", error)>
		<!--- Custom Error Template or Coldbox --->
		<cfset ErrorTemplate = session.fwController.getSetting("CustomErrorTemplate")>
		<cfif ErrorTemplate neq "">
			<cfinclude template="/#session.fwController.getSetting("AppCFMXMapping")#/#ErrorTemplate#">
			<cfabort>
		</cfif>
	</cfif>	
	
	<cfoutput>
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
	<title>Unexpected Error</title>
	<!--- Style --->
	<style>
	<cfinclude template="style.css">
	</style>
	</head>
	<body >
	<table width="98%" border="0" align="center" cellpadding="0" cellspacing="5" class="fw_errorTables" style="border:1px solid ##999999">
	  <tr>
	    <td colspan="2" class="fw_errorTitles"> Unexpected Error Occurred. </td>
	  </tr>
	  <tr>
	    <td width="95" align="center" valign="middle"><img src="#session.fwController.getSetting("DistanceString",1)#system/includes/images/error_sm.gif" alt="Error" width="75" height="71" /></td>
	    <td valign="middle" class="fw_errorText">An unexpected error occurred while rendering this page. The administrator has been informed about the error. <br>
	    The information below is to be used by the developers of this application for debugging the application.
		<br>
		<br>
		Please try to refresh or press the button below to go to the home page.<br>
		<input type="button" onClick="window.location='index.cfm'" value="Go To Home Page">
		</td>
	  </tr>
	  <tr>
	    <td align="right" valign="top" class="fw_errorTablesTitles" >Date:</td>
	    <td width="924" valign="top" class="fw_errorTablesCells">#dateFormat(error.DateTime, "MMM DD YYYY")# #timeformat(error.DateTime, "HH:MM:SS")#</td>
	  </tr>
	  <tr>
	    <td align="right" valign="top" class="fw_errorTablesTitles">Diagnostics:</td>
	    <td valign="top" class="fw_errorTablesCells">
		<span class="fw_redText">#error.Diagnostics#</span>
		</td>
	  </tr>
	  <cfif structKeyExists(request.reqCollection, "event")>
	  <tr>
	    <td width="122" align="right" class="fw_errorTablesTitles">Current Event: </td>
	    <td width="463" class="fw_errorTablesCells">#request.reqCollection.event#</td>
	  </tr>
	  </cfif>
	  <cfif structKeyExists(request.reqCollection, "currentLayout")>
	  <tr>
	    <td align="right" class="fw_errorTablesTitles">Current Layout: </td>
	    <td class="fw_errorTablesCells">#request.reqCollection.currentLayout#</td>
	  </tr>
	  </cfif>
	  <cfif structKeyExists(request.reqCollection, "currentView")>
	  <tr>
	    <td align="right" class="fw_errorTablesTitles">Current View: </td>
	    <td class="fw_errorTablesCells">#request.reqCollection.currentView#</td>
	  </tr>
	  </cfif>
	  <tr>
	    <td colspan="2" class="fw_errorTitles">Exception Structure </td>
	  </tr>
	  	  <cfif structKeyExists(error, "type")>
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Error Type & Code:</td>
		  </tr>  
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">
				<cfif structkeyExists(error,"RootCause") and structkeyExists(error.RootCause,"Type")>#error.RootCause.type#</cfif> - #error.type# : <cfif error.errorCode eq "">[N/A]<cfelse>#error.ErrorCode#</cfif></td>
		  </tr>
		  </cfif>
		  <cfif structKeyExists(error, "RootCause") and isSimpleValue(error.RootCause)>	
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Root Cause:</td>
		  </tr>  
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.rootCause#</td>
		  </tr>
		  </cfif>
		  <cfif structKeyExists(error, "ExtendedInfo") and error.ExtendedInfo neq "">
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Extended Info:</td>
		  </tr>  
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.ExtendedInfo#</td>
		  </tr>	
		  </cfif>	   
		  <cfif structKeyExists(error, "Message") >
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Message:</td>
		  </tr>  
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.message#</td>
		  </tr>
		  </cfif>
		  <cfif structKeyExists(error, "Detail") >
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Detail:</td>
		  </tr>  
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.Detail#</td>
		  </tr>
		  </cfif>
		  <cfif structKeyExists(error, "missingFileName") >
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Missing File Name:</td>
		  </tr>  
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.missingFileName#</td>
		  </tr>
		  </cfif>
		  <cfif structKeyExists(error, "name") >
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Method Name:</td>
		  </tr>  
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.name#</td>
		  </tr>
		  </cfif>
		  <cfif structKeyExists(error, "args") >
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Arguments:</td>
		  </tr>  
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.args#</td>
		  </tr>
		  </cfif>
		  <cfif structKeyExists(error, "type") and findnocase("database", error.type)>
		  <tr >
			<td colspan="2" class="fw_errorTitles">Database Exception Information:</td>
		  </tr>
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">NativeErrorCode & SQL State:</td>
		  </tr>
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.NativeErrorCode# : #error.SQLState#</td>
		  </tr>
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">SQL Sent:</td>
		  </tr>
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.SQL#</td>
		  </tr>
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Database Driver Error Message:</td>
		  </tr>
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.queryError#</td>
		  </tr>
		  <tr >
			<td colspan="2" class="fw_errorTablesTitles">Name-Value Pairs:</td>
		  </tr>
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.where#</td>
		  </tr>
		  </cfif>
		  <cfif structKeyExists(error, "stackTrace")>
		  <tr >
			<td colspan="2" class="fw_errorTitles">Stack Trace:</td>
		  </tr>
		  <tr>
			<td colspan="2" class="fw_errorTablesCells">#error.stackTrace#</td>
		  </tr>
		  </cfif>		  
		  <cfif structKeyExists(error, "tagContext") >
		  <tr >
			<td colspan="2" class="fw_errorTitles">Tag Context:</td>
		  </tr>
		  <cfloop from="1" to="#arrayLen(error.TagContext)#" index="i">
		  <tr >
			<td align="right" class="fw_errorTablesTitles">ID:</td>
		    <td class="fw_errorTablesCells"><cfif not structKeyExists(error.TagContext[i], "ID")>??<cfelse>#error.TagContext[i].ID#</cfif></td>
		  </tr>  
		   
		   <tr >
			<td align="right" class="fw_errorTablesTitles">LINE:</td>
		    <td class="fw_errorTablesCells">#error.TagContext[i].LINE#</td>
		   </tr>  
		  
		   <tr >
			<td align="right" class="fw_errorTablesTitles">Template:</td>
		    <td class="fw_errorTablesCells">#error.TagContext[i].Template#</td>
		   </tr>  
		   <tr >
			<td colspan="2"></td>
		    </tr> 
		  </cfloop>
		  </cfif>
	</table>
	<p>&nbsp;</p>
	</body>
	</html>
	<!--- Framework Debugging if Available--->
	<cfif structKeyExists(session, "fwController") and session.fwController.getDebugMode()>
		<!--- Request Total Time --->
		<cfset request.execTime = GetTickCount() - request.execTime>	
		#session.fwController.getPlugin("renderer").renderDebugLog()#
	</cfif>
	</cfoutput>
<cfsetting enablecfoutputonly=false>
